#include "util.h"
#include "datafiles.h"
#include "commands.h"
#include "nnonspikeunits.h"

void save_as_dat(const nns_project& pro, string newfname, int opt) {
//	newfname = pro.datapath + "\\" + newfname;
	newfname = pro.datapath + newfname; // modified by SM 2/19/2016
	save_dat(pro, newfname, opt);
};

void save_dat(const nns_project& pro, int opt) {
	string tmpfn;
	tmpfn = pro.datapath + pro.name + ".dat";
	save_dat(pro, tmpfn, opt);
};

void save_dat(const nns_project& pro, string filename, int opt) {
	int wds = 0, wde = 0;
	int prec = 2, iPP = 0, iNP = 0;
	//int allstep = int( pro.pops[0].paraset.ctr_para.simduration/pro.pops[0].paraset.ctr_para.simstep);
	int allstep = int(pro.ctr_para.simduration / pro.ctr_para.simstep);
	
	string tmpstr;
	vector<int> neuTemp;
	vector<vector<int>> neuList;
	vector<int> popList;
	vector<int> nsuList;

	//wde = (int)pro.pops[0].paraset.ctr_para.simduration;
	wde = (int)pro.ctr_para.simduration;
	
	ofstream file(filename);
	if (file.is_open())
	{
		file << "<Header>" << endl;
		file << "NNS Data ASCII format V1.0" << endl;
		file << "Generated by NNS V1.0" << endl;
		file << "</Header>" << endl;
		file << "<Record>" << endl;

		file << "Saved window = ["<< wds << "," << wde << "] msec" << endl;
		file << "Duration = " << wde- wds << " msec" << endl;
		//file << "Precision = " << pro.pops[0].paraset.ctr_para.simstep << " msec" << endl;
		file << "Precision = " << pro.ctr_para.simstep << " msec" << endl;
		file << "NDataType = " << pro.iodata.size() << endl;

		for (int id = 0;id < (int)pro.iodata.size();id++) {
			if (pro.iodata[id].save == 1) {
				//Making full lists of pop and neu
				for (int j = 0;j < (int)pro.iodata[id].popList.size();j++) {
					if (pro.iodata[id].popList[j][1] != -1) {
						for (int jt = 0;jt < pro.iodata[id].popList[j][1] - pro.iodata[id].popList[j][0] + 1;jt++) {
							popList.push_back(pro.iodata[id].popList[j][0] + jt);
						};
					}
					else {
						popList.push_back(pro.iodata[id].popList[j][0]);
					};
				};
				for (int jp = 0;jp < pro.iodata[id].npop;jp++) {
					neuTemp.clear();
					for (int jn = 0;jn < (int)pro.iodata[id].neuList[jp].size();jn++) {
						if (pro.iodata[id].neuList[jp][jn][1] != -1) {
							for (int jnn = 0;jnn < pro.iodata[id].neuList[jp][jn][1] - pro.iodata[id].neuList[jp][jn][0] + 1;jnn++) {
								neuTemp.push_back(pro.iodata[id].neuList[jp][jn][0] + jnn);
							};
						}
						else {
							neuTemp.push_back(pro.iodata[id].neuList[jp][jn][0]);
						};
					};
					neuList.push_back(neuTemp);
				};
				if (pro.iodata[id].nnsu != 0) {
					nsuList.resize(pro.iodata[id].nnsu);
					int cut = 0;
					for (int j = 0;j < (int)pro.iodata[id].nsuList.size();j++) {
						if (pro.iodata[id].nsuList[j][1] != -1) {
							for (int jt = 0;jt < pro.iodata[id].nsuList[j][1] - pro.iodata[id].nsuList[j][0] + 1;jt++) {
								nsuList[cut] = pro.iodata[id].nsuList[j][0] + jt;
								cut++;
							};
						}
						else {
							nsuList[cut] = pro.iodata[id].nsuList[j][0];
							cut++;
						};
					};
				};
				iPP = 0, iNP = 0;
				file << "<DataType " << pro.iodata[id].type << ">" << endl;
				file << "SavedNPop = " << pro.iodata[id].npop << endl;
				if (pro.iodata[id].type == 16) {
					file << "SavedNNSU = " << pro.iodata[id].nnsu << endl;
				};
				//popluation
				for (int ip = 0;ip < pro.iodata[id].npop;ip++) {
					file << "<Pop " << ip << ">" << endl;
					file << "Name = " << pro.pops[popList[ip]].name << endl;
					file << "Size = " << pro.pops[popList[ip]].nneurons << endl;
					file << "Threshold = " << pro.pops[ip].threshold << endl;
					file << "SavedNNeu = " << pro.iodata[id].nneu[ip] << endl;

					//Neurons
					for (int in = 0;in < pro.iodata[id].nneu[ip];in++) {
						file << "<Neu " << in << " (" << neuList[ip][in] << ")>" << endl;
						if (pro.iodata[id].type != 18) {
							for (int is = 0;is < allstep;is++) {
								//file << roundd( pro.iodata[id].data[iPP + in*allstep + is],prec) << endl;
								file << pro.iodata[id].data[iPP + in*allstep + is] << endl;
							};
						}
						else { //For spikes info
							file << "NSpikes = " << pro.iodata[id].data[iNP] << endl;
							for (int is = 0;is < pro.iodata[id].data[iNP];is++) {
								//file << roundd(pro.iodata[id].data[iNP + is + 1], prec) << endl;
								file << pro.iodata[id].data[iNP + is + 1] << endl;
							};
							//iNP = iNP + pro.iodata[id].data[iNP];
							iNP = int( iNP + pro.iodata[id].data[iNP] + 1); //10.13.2015
						};				
						file << "</Neu " << in << ">" << endl;
					};
					iPP = iPP + pro.iodata[id].nneu[ip] * allstep;
					file << "</Pop " << ip << ">" << endl;
				};

				if (pro.iodata[id].type == 16) {
					for (int iu = 0;iu < pro.iodata[id].nnsu;iu++) {
						file << "<NSU " << iu << ">" << endl;
						file << "Name = " << pro.nsu.units[nsuList[iu]].name << endl;
						file << "UType = " << pro.nsu.units[nsuList[iu]].type << endl;
						for (int is = 0; is < allstep;is++) {
							file << pro.iodata[id].data[iPP + iu*allstep + is] << endl;
						};

						file << "</NSU " << iu << ">" << endl;
					};
				};

				file << "</DataType " << pro.iodata[id].type << ">" << endl;
				popList.clear();
				neuList.clear();
			};
		};

		file << "</Record>" << endl;
	};

	file.close();
	cout << "NNS data file was saved as " << filename << endl;
};

void save_as_nns(const nns_project& pro, string newfname) {
	newfname = pro.nnspath + "\\" + newfname;
	save_nns(pro, newfname);
};

void save_nns(const nns_project& pro) {
	//stringstream tmpx;
	//tmpx << pro.name << ".nns";
	//save_nns(pro, tmpx.str());
	string tmp;
	tmp = pro.nnspath + "\\" + pro.name + ".nns";
	save_nns(pro, tmp);
};

//void save_nns(const vector<neural_population>& pops, const vector<nns_net>& nets, const vector<nns_mnet>& mnets, string fname) {
void save_nns(const nns_project& pro,string fname) {
	
	int npops = (int)pro.pops.size();
	int nichs = 0;
	int nions = 0;
	int nnets = (int)pro.tnet.nets.size();
	int nmnets = (int)pro.tnet.mnets.size();
	int nsynps = 4;

	ofstream nns (fname);
	if (nns.is_open())
	{
		nns << "Neural Network Simulator (NNS), 2015(C)" << endl;
		nns << endl;

		//Vesion definition
		nns << "<VERSION>" << endl;
		nns << "NNS V1.0" << endl;
		nns << "</VERSION>" << endl;
		nns << endl;

		//Control parameter defintion
		nns << "<CTR PARAM>" << endl;
		// nns << "Seed = " << pro.pops[0].paraset.ctr_para.seed << endl;
		// nns << "SimStep = " << pro.pops[0].paraset.ctr_para.simstep << endl;
		// nns << "SimDuration = " << pro.pops[0].paraset.ctr_para.simduration << endl;
				nns << "Seed = " << pro.ctr_para.seed << endl;
		nns << "SimStep = " << pro.ctr_para.simstep << endl;
		nns << "SimDuration = " << pro.ctr_para.simduration << endl;
		//nns<<"Threshold = "<<pro.pops[0].paraset.ctr_para.threshold<<endl;
		nns << "</CTR PARAM>" << endl;
		nns << endl;

		//Synapse type definition
		nns << "<SYNAPSE PARAM>" << endl;
		nns << "N of SynapseType = " << nsynps << endl;
		nns << endl;

		for (int isp = 0; isp < nsynps; isp++) {
			nns << "<SYNP " << isp << ">" << endl;
			nns << "Name = " << pro.pops[0].paraset.ichs.ng_para[isp].name << endl;
			nns << "IonType = " << pro.pops[0].paraset.ichs.ng_para[isp].Itype << endl;
			nns << "Gm = " << pro.pops[0].paraset.ichs.ng_para[isp].g.val << " (" << pro.pops[0].paraset.ichs.ng_para[isp].g.var << ")" <<endl;
			nns << "E = " << pro.pops[0].paraset.ichs.ng_para[isp].E.val << " (" << pro.pops[0].paraset.ichs.ng_para[isp].E.var << ")" << endl;
			nns << "Tc = " << pro.pops[0].paraset.ichs.ng_para[isp].Tc << endl;
			nns << "Amp = " << pro.pops[0].paraset.ichs.ng_para[isp].Amp << endl;
			nns << "</SYNP " << isp << ">" << endl;
		};

		nns << "</SYNAPSE PARAM>" << endl;
		nns << endl;

		//Populations definition
		nns << "<POPULATIONS>" << endl;
		nns << "N of Pops = " << npops << endl;

		nns << endl;
		for (int i = 0;i < npops;i++)
		{
			nichs = pro.pops[i].paraset.ichs.nIChs;
			nions = pro.pops[i].paraset.ions.nIons;
			nns << "<POP " << i << ">" << endl;
			nns << "Name = " << pro.pops[i].name << endl;
			nns << "ID = " << pro.pops[i].ID << endl;
			nns << "Size = " << pro.pops[i].nneurons << endl;
			nns << "Threshold = " << pro.pops[i].threshold << endl;
			nns << endl;

			nns << "<NEURON PARAM>" << endl;
			nns << "Cm = " << pro.pops[i].paraset.neu_para.Cm.val << " (" << pro.pops[i].paraset.neu_para.Cm.var << ")" << endl;
			nns << "Vm = " << pro.pops[i].paraset.neu_para.Vm.val << " (" << pro.pops[i].paraset.neu_para.Vm.var << ")" << endl;
			nns << "Area = " << pro.pops[i].paraset.neu_para.area << endl;
			nns << "Type = " << pro.pops[i].paraset.neu_para.neuT << endl;
			nns << endl;

			nns << "<ICHANNELS PARAM>" << endl;
			nns << "nICH = " << pro.pops[i].paraset.ichs.nIChs - nsynps << endl;
			nns << "nICHNameList = {";
			for (int j = 0;j < nichs - nsynps;j++) {
				if (j != nichs - nsynps - 1)
					nns << pro.pops[i].paraset.ichs.IChNList[j + nsynps] << ", ";
				else
					nns << pro.pops[i].paraset.ichs.IChNList[j + nsynps] << "}" << endl;
			};
			nns << "nICHGTypeList = {";
			for (int j = 0;j < nichs - nsynps;j++) {
				if (j != nichs - nsynps - 1)
					nns << pro.pops[i].paraset.ichs.IChGTList[j + nsynps] << ", ";
				else
					nns << pro.pops[i].paraset.ichs.IChGTList[j + nsynps] << "}" << endl;
			};

			nns << "nICHMHTypeList = {";
			for (int j = 0;j < nichs - nsynps;j++) {
				if (j != nichs - nsynps - 1)
					nns << pro.pops[i].paraset.ichs.IChMHTList[j + nsynps] << ", ";
				else
					nns << pro.pops[i].paraset.ichs.IChMHTList[j + nsynps] << "}" << endl;
			};
			nns << "nICHITypeList = {";
			for (int j = 0;j < nichs - nsynps;j++) {
				if (j != nichs - nsynps - 1)
					nns << pro.pops[i].paraset.ichs.IChIonTList[j + nsynps] << ", ";
				else
					nns << pro.pops[i].paraset.ichs.IChIonTList[j + nsynps] << "}" << endl;
			};

			nns << "nICHDStatusList = {";
			for (int j = 0;j < nichs - nsynps;j++) {
				if (j != nichs - nsynps - 1)
					nns << pro.pops[i].paraset.ichs.IChDSList[j + nsynps] << ", ";
				else
					nns << pro.pops[i].paraset.ichs.IChDSList[j + nsynps] << "}" << endl;
			};
			nns << endl;

			int gi;
			for (int j = 0;j < nichs - nsynps;j++)
			{
				nns << "<ICH " << j << ">" << endl;
				//switch (ichl.at(j))
				//switch (ichl[j])				
				switch (pro.pops[i].paraset.ichs.IChIdxList[j + nsynps][0])
				{
				case 0:
					gi = pro.pops[i].paraset.ichs.IChIdxList[j + nsynps][1];
					nns << "Name = " << pro.pops[i].paraset.ichs.g_para[gi].name << endl;
					//nns << "ID = " << pro.pops[i].paraset.ichs.g_para[gi].ID << endl;
					//nns << "Type = " << pro.pops[i].paraset.ichs.g_para[gi].type << endl;
					//nns << "MHType = " << pro.pops[i].paraset.ichs.g_para[gi].MHtype << endl;

					nns << "g = " << pro.pops[i].paraset.ichs.g_para[gi].g.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].g.var << ")" << endl;
					nns << "E = " << pro.pops[i].paraset.ichs.g_para[gi].E.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].E.var << ")" << endl;
					nns << "mpower = " << pro.pops[i].paraset.ichs.g_para[gi].mpower << endl;
					nns << "hpower = " << pro.pops[i].paraset.ichs.g_para[gi].hpower << endl;

					nns << "M0 = " << pro.pops[i].paraset.ichs.g_para[gi].M0 << endl;
					nns << "H0 = " << pro.pops[i].paraset.ichs.g_para[gi].H0 << endl;

					nns << "t0m = " << pro.pops[i].paraset.ichs.g_para[gi].t0m << endl;
					nns << "t0h = " << pro.pops[i].paraset.ichs.g_para[gi].t0h << endl;
					nns << "tm = " << pro.pops[i].paraset.ichs.g_para[gi].tm.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].tm.var << ")" << endl;
					nns << "th = " << pro.pops[i].paraset.ichs.g_para[gi].th.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].th.var << ")" << endl;

					nns << "V12m = " << pro.pops[i].paraset.ichs.g_para[gi].Vsm.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].Vsm.var << ")" << endl;
					nns << "V12tm = " << pro.pops[i].paraset.ichs.g_para[gi].Vhfm.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].Vhfm.var << ")" << endl;
					nns << "V12tm2 = " << pro.pops[i].paraset.ichs.g_para[gi].Vhfm2.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].Vhfm2.var << ")" << endl;
					nns << "km = " << pro.pops[i].paraset.ichs.g_para[gi].km.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].km.var << ")" << endl;
					nns << "ktm = " << pro.pops[i].paraset.ichs.g_para[gi].ktm.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].ktm.var << ")" << endl;
					nns << "ktm2 = " << pro.pops[i].paraset.ichs.g_para[gi].ktm2.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].ktm2.var << ")" << endl;

					nns << "V12h = " << pro.pops[i].paraset.ichs.g_para[gi].Vsh.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].Vsh.var << ")" << endl;
					nns << "V12th = " << pro.pops[i].paraset.ichs.g_para[gi].Vhfh.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].Vhfh.var << ")" << endl;
					nns << "V12th2 = " << pro.pops[i].paraset.ichs.g_para[gi].Vhfh2.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].Vhfh2.var << ")" << endl;
					nns << "kh = " << pro.pops[i].paraset.ichs.g_para[gi].kh.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].kh.var << ")" << endl;
					nns << "kth = " << pro.pops[i].paraset.ichs.g_para[gi].kth.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].kth.var << ")" << endl;
					nns << "kth2 = " << pro.pops[i].paraset.ichs.g_para[gi].kth2.val << " (" << pro.pops[i].paraset.ichs.g_para[gi].kth2.var << ")" << endl;

					break;
				case 1:
					gi = pro.pops[i].paraset.ichs.IChIdxList[j + nsynps][1];
					nns << "Name = " << pro.pops[i].paraset.ichs.ab_para[gi].name << endl;
					//nns << "ID = " << pro.pops[i].paraset.ichs.ab_para[gi].ID << endl;
					//nns << "Type = " << pro.pops[i].paraset.ichs.ab_para[gi].type << endl;
					//nns << "MHType = " << pro.pops[i].paraset.ichs.ab_para[gi].MHtype << endl;

					nns << "g = " << pro.pops[i].paraset.ichs.ab_para[gi].g.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].g.var << ")" << endl;
					nns << "E = " << pro.pops[i].paraset.ichs.ab_para[gi].E.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].E.var << ")" << endl;
					nns << "mpower = " << pro.pops[i].paraset.ichs.ab_para[gi].mpower << endl;
					nns << "hpower = " << pro.pops[i].paraset.ichs.ab_para[gi].hpower << endl;

					nns << "M0 = " << pro.pops[i].paraset.ichs.ab_para[gi].M0 << endl;
					nns << "H0 = " << pro.pops[i].paraset.ichs.ab_para[gi].H0 << endl;

					nns << "t0m = " << pro.pops[i].paraset.ichs.ab_para[gi].t0m << endl;
					nns << "t0h = " << pro.pops[i].paraset.ichs.ab_para[gi].t0h << endl;
					nns << "tm = " << pro.pops[i].paraset.ichs.ab_para[gi].tmaxm << endl;
					nns << "th = " << pro.pops[i].paraset.ichs.ab_para[gi].tmaxh << endl;

					nns << "MAa = " << pro.pops[i].paraset.ichs.ab_para[gi].MAa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MAa.var << ")" << endl;
					nns << "MBa = " << pro.pops[i].paraset.ichs.ab_para[gi].MBa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MBa.var << ")" << endl;
					nns << "MCa = " << pro.pops[i].paraset.ichs.ab_para[gi].MCa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MCa.var << ")" << endl;
					nns << "MDa = " << pro.pops[i].paraset.ichs.ab_para[gi].MDa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MDa.var << ")" << endl;
					nns << "MEa = " << pro.pops[i].paraset.ichs.ab_para[gi].MEa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MEa.var << ")" << endl;

					nns << "MAb = " << pro.pops[i].paraset.ichs.ab_para[gi].MAb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MAb.var << ")" << endl;
					nns << "MBb = " << pro.pops[i].paraset.ichs.ab_para[gi].MBb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MBb.var << ")" << endl;
					nns << "MCb = " << pro.pops[i].paraset.ichs.ab_para[gi].MCb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MCb.var << ")" << endl;
					nns << "MDb = " << pro.pops[i].paraset.ichs.ab_para[gi].MDb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MDb.var << ")" << endl;
					nns << "MEb = " << pro.pops[i].paraset.ichs.ab_para[gi].MEb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].MEb.var << ")" << endl;

					nns << "HAa = " << pro.pops[i].paraset.ichs.ab_para[gi].HAa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HAa.var << ")" << endl;
					nns << "HBa = " << pro.pops[i].paraset.ichs.ab_para[gi].HBa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HBa.var << ")" << endl;
					nns << "HCa = " << pro.pops[i].paraset.ichs.ab_para[gi].HCa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HCa.var << ")" << endl;
					nns << "HDa = " << pro.pops[i].paraset.ichs.ab_para[gi].HDa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HDa.var << ")" << endl;
					nns << "HEa = " << pro.pops[i].paraset.ichs.ab_para[gi].HEa.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HEa.var << ")" << endl;

					nns << "HAb = " << pro.pops[i].paraset.ichs.ab_para[gi].HAb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HAb.var << ")" << endl;
					nns << "HBb = " << pro.pops[i].paraset.ichs.ab_para[gi].HBb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HBb.var << ")" << endl;
					nns << "HCb = " << pro.pops[i].paraset.ichs.ab_para[gi].HCb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HCb.var << ")" << endl;
					nns << "HDb = " << pro.pops[i].paraset.ichs.ab_para[gi].HDb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HDb.var << ")" << endl;
					nns << "HEb = " << pro.pops[i].paraset.ichs.ab_para[gi].HEb.val << " (" << pro.pops[i].paraset.ichs.ab_para[gi].HEb.var << ")" << endl;

					break;
				case 2:
					gi = pro.pops[i].paraset.ichs.IChIdxList[j + nsynps][1];
					nns << "Name = " << pro.pops[i].paraset.ichs.z_para[gi].name << endl;
					//nns << "ID = " << pro.pops[i].paraset.ichs.z_para[gi].ID << endl;
					//nns << "Type = " << pro.pops[i].paraset.ichs.z_para[gi].type << endl;
					//nns << "MHType = " << pro.pops[i].paraset.ichs.z_para[gi].MHtype << endl;

					nns << "g = " << pro.pops[i].paraset.ichs.z_para[gi].g.val << " (" << pro.pops[i].paraset.ichs.z_para[gi].g.var << ")" << endl;
					nns << "E = " << pro.pops[i].paraset.ichs.z_para[gi].E.val << " (" << pro.pops[i].paraset.ichs.z_para[gi].E.var << ")" << endl;
					nns << "mpower = " << pro.pops[i].paraset.ichs.z_para[gi].mpower << endl;
					nns << "hpower = " << pro.pops[i].paraset.ichs.z_para[gi].hpower << endl;

					nns << "M0 = " << pro.pops[i].paraset.ichs.z_para[gi].M0 << endl;
					nns << "H0 = " << pro.pops[i].paraset.ichs.z_para[gi].H0 << endl;

					nns << "A = " << pro.pops[i].paraset.ichs.z_para[gi].A.val << " (" << pro.pops[i].paraset.ichs.z_para[gi].A.var << ")" << endl;
					nns << "B = " << pro.pops[i].paraset.ichs.z_para[gi].B.val << " (" << pro.pops[i].paraset.ichs.z_para[gi].B.var << ")" << endl;
					nns << "L = " << pro.pops[i].paraset.ichs.z_para[gi].L.val << " (" << pro.pops[i].paraset.ichs.z_para[gi].L.var << ")" << endl;
					nns << "G = " << pro.pops[i].paraset.ichs.z_para[gi].G.val << " (" << pro.pops[i].paraset.ichs.z_para[gi].G.var << ")" << endl;
					nns << "Vhf = " << pro.pops[i].paraset.ichs.z_para[gi].Vhf.val << " (" << pro.pops[i].paraset.ichs.z_para[gi].Vhf.var << ")" << endl;
					nns << "slp = " << pro.pops[i].paraset.ichs.z_para[gi].slp.val << " (" << pro.pops[i].paraset.ichs.z_para[gi].slp.var << ")" << endl;

					nns << "t0 = " << pro.pops[i].paraset.ichs.z_para[gi].t0 << endl;
					nns << "tmax = " << pro.pops[i].paraset.ichs.z_para[gi].tmax << endl;

					break;
				case 3:
					gi = pro.pops[i].paraset.ichs.IChIdxList[j + nsynps][1];
					nns << "Name = " << pro.pops[i].paraset.ichs.ng_para[gi].name << endl;
					//nns << "ID = " << pro.pops[i].paraset.ichs.ng_para[gi].ID << endl;
					//nns << "Type = " << pro.pops[i].paraset.ichs.ng_para[gi].type << endl;
					//nns << "MHType = " << pro.pops[i].paraset.ichs.ng_para[gi].MHtype << endl;

					nns << "g = " << pro.pops[i].paraset.ichs.ng_para[gi].g.val << " (" << pro.pops[i].paraset.ichs.ng_para[gi].g.var << ")" << endl;
					nns << "E = " << pro.pops[i].paraset.ichs.ng_para[gi].E.val << " (" << pro.pops[i].paraset.ichs.ng_para[gi].E.var << ")" << endl;

					break;

				};
				nns << "</ICH " << j << ">" << endl;
				nns << endl;
			};

			nns << "</ICHANNELS PARAM>" << endl;
			nns << "</NEURON PARAM>" << endl;
			nns << endl;
			nns << "<IONS PARAM>" << endl;
			nns << "nIONS = " << pro.pops[i].paraset.ions.nIons << endl;
			for (int j = 0;j < nions;j++)
			{
				nns << "<ION " << j << ">" << endl;

				nns << "Name = " << pro.pops[i].paraset.ions.ion_para[j].name << endl;
				nns << "ID = " << pro.pops[i].paraset.ions.ion_para[j].ID << endl;
				nns << "IonType = " << pro.pops[i].paraset.ions.ion_para[j].ionType << endl;
				//nns << "Cin = " << pro.pops[i].paraset.ions.ion_para[j].Cin << endl;
				nns << "PumpType = " << pro.pops[i].paraset.ions.ion_para[j].pumpType << endl;
				nns << "Cin = " << pro.pops[i].paraset.ions.ion_para[j].Cin << endl;
				nns << "Cout = " << pro.pops[i].paraset.ions.ion_para[j].Cout << endl;
				//nns << "E = " << pro.pops[i].paraset.ions.ion_para[j].E << endl;
				//nns << "R = " << pro.pops[i].paraset.ions.ion_para[j].R << endl;
				//nns << "F = " << pro.pops[i].paraset.ions.ion_para[j].F << endl;
				//nns << "T = " << pro.pops[i].paraset.ions.ion_para[j].T << endl;
				nns << "Z = " << pro.pops[i].paraset.ions.ion_para[j].Z << endl;
				nns << "InEq = " << pro.pops[i].paraset.ions.ion_para[j].InEq << endl;
				nns << "t = " << pro.pops[i].paraset.ions.ion_para[j].t << endl;
				nns << "Rpmp = " << pro.pops[i].paraset.ions.ion_para[j].Rpmp << endl;
				nns << "Rch = " << pro.pops[i].paraset.ions.ion_para[j].Rch << endl;
				nns << "Kp = " << pro.pops[i].paraset.ions.ion_para[j].Kp << endl;
				nns << "K = " << pro.pops[i].paraset.ions.ion_para[j].K << endl;
				nns << "B = " << pro.pops[i].paraset.ions.ion_para[j].B << endl;

				nns << "</ION " << j << ">" << endl;
				nns << endl;
			};
			nns << "</IONS PARAM>" << endl;
			nns << endl;
			nns << "</POP " << i << ">" << endl;
			nns << endl;
		};
		nns << "</POPULATIONS>" << endl;
		nns << endl;

		//NSUs definition
		nns << "<NSUNITS>" << endl;
		nns << endl;

		nns << "<DRIVES>" << endl;
		nns << endl;

		for (int d = 0;d < (int)pro.nsu.units.size();d++) {
			if (pro.nsu.units[d].type == NSU_DRIVE)
			nns << "[" << pro.nsu.units[d].name << "]" << endl;
		}

		nns << "</DRIVES>" << endl;
		nns << endl;

		nns << "<OUTPUTS>" << endl;
		nns << endl;

		nns << "//Syntax for outputs:" << endl;
		nns << "//[name; Tup; Tdown; threshold]" << endl;
		nns << endl;

		for (int d = 0;d < (int)pro.nsu.units.size();d++) {
			if (pro.nsu.units[d].type == NSU_OUTPUT)
			nns << "[" << pro.nsu.units[d].name << ";" << pro.nsu.units[d].Tup << ";" << pro.nsu.units[d].Tdown << ";" << pro.nsu.units[d].Threshold << ";" << "]" << endl;
		}

		nns << "</OUTPUTS>" << endl;
		nns << endl;

		nns << "</NSUNITS>" << endl;
		nns << endl;

		//All Networks definition
		nns << "<NETWORKS>" << endl;
		nns << endl;
		//nns << "Optimization = " << pro.tnet.Optima << endl;
		nns << "N of Nets = " << nnets << endl;
		nns << "N of MNets = " << nmnets << endl;
		nns << endl;

		nns << "//Synapse Types - Excitation1:0, Excitation2:1, Inhibition1:2, Inhibition2:3" << endl;
		nns << "//Syntax for Nets: (To select a nonspike unit, use u: to specify nonspike unit before the name)" << endl;
		nns << "//[optimization OnOff;normalization OnOff;synapse type;source popname;target popname; connection prob; weight]" << endl;
		nns << "//[optimization OnOff;normalization OnOff;synapse type;u:source unitname;target popname; connection prob; weight]" << endl;
		nns << "// For All to all connection: " << endl;
		nns << "//[optimization OnOff;normalization OnOff;synapse type;source popname;target popname; weight]&*" << endl;
		nns << "// For All to all connection with a network plasticity rate:" << endl;
		nns << "//[optimization OnOff;normalization OnOff;synapse type;source popname;target popname; weight; prate]&*&p" << endl;
		nns << "// For one to one connection: " << endl;
		nns << "//[optimization OnOff;normalization OnOff;synapse type;source popname;target popname; weight]&n" << endl;
		nns << "// For one to one connection with a network plasticity rate:" << endl;
		nns << "//[optimization OnOff;normalization OnOff;synapse type;source popname;target popname; weight; prate]&n&p" << endl;
		nns << "//Syntax for MNets:" << endl;
		nns << "//[optimization OnOff;normalization OnOff;synapse type;source netname:popname;target netname:popname; connection prob; weight]" << endl;
		nns << endl;

		for (int i = 0;i < nnets;i++) {

			nns << "<NET " << i << ">" << endl;
			nns << "Name = " << pro.tnet.nets[i].name << endl;
			nns << "OnOff = " << pro.tnet.nets[i].OnOff << endl;
			//nns << "nList = " << pro.tnet.nets[i].nList << endl;

			nns << "pnameList = {";
			for (int j = 0;j < pro.tnet.nets[i].nList;j++) {
				if (j != pro.tnet.nets[i].nList - 1)
					nns << pro.tnet.nets[i].pnameList[j] << ", ";
				else
					nns << pro.tnet.nets[i].pnameList[j] << "}" << endl;
			};
			nns << "unameList = {";
			for (int j = 0;j < pro.tnet.nets[i].nList;j++) {
				if (j != pro.tnet.nets[i].nList - 1)
					nns << pro.tnet.nets[i].pnameList[j] << ", ";
				else
					nns << pro.tnet.nets[i].pnameList[j] << "}" << endl;
			};


			for (int j = 0;j < (int)pro.tnet.nets[i].pconn.size();j++) {
				nns << "[" << pro.tnet.nets[i].pconn[j].optmz_OnOff << ";" << pro.tnet.nets[i].pconn[j].norm_OnOff << ";" << pro.tnet.nets[i].pconn[j].syntype << ";" << pro.pops[pro.tnet.nets[i].pconn[j].sid].name << ";" << pro.pops[pro.tnet.nets[i].pconn[j].tid].name << ";" << pro.tnet.nets[i].pconn[j].sprob.val << "(" << pro.tnet.nets[i].pconn[j].sprob.var << ")" << ";" << pro.tnet.nets[i].pconn[j].tprob.val << "(" << pro.tnet.nets[i].pconn[j].tprob.var << ")" << ";" << pro.tnet.nets[i].pconn[j].w.val << "(" << pro.tnet.nets[i].pconn[j].w.var << ")" << "]" << endl;
			};
			nns << "</NET " << i << ">" << endl;
			nns << endl;
		};

		for (int i = 0;i < nmnets;i++) {

			nns << "<MNET " << i << ">" << endl;
			nns << "Name = " << pro.tnet.mnets[i].name << endl;
			nns << "OnOff = " << pro.tnet.mnets[i].OnOff << endl;
			//nns << "nList = " << pro.tnet.mnets[i].nList << endl;

			nns << "nnameList = {";
			for (int j = 0;j < pro.tnet.mnets[i].nList;j++) {
				if (j != pro.tnet.mnets[i].nList - 1)
					nns << pro.tnet.mnets[i].nnameList[j] << ", ";
				else
					nns << pro.tnet.mnets[i].nnameList[j] << "}" << endl;
			};

			//nns << "nidList = {";
			//for (int j = 0;j < pro.tnet.mnets[i].nList;j++) {
			//	if (j != pro.tnet.mnets[i].nList - 1)
			//		nns << pro.tnet.mnets[i].nidList[j] << ", ";
			//	else
			//		nns << pro.tnet.mnets[i].nidList[j] << "}" << endl;
			//};

			for (int j = 0;j < (int)pro.tnet.mnets[i].nconn.size();j++) {
				//nns << "<NCONN " << j << ">" << endl;
				//nns << "Source Net = " << pro.tnet.mnets[i].nconn[j].snet << endl;
				//nns << "Source Pop = " << pro.tnet.mnets[i].nconn[j].spop << endl;
				//nns << "Source Prob = " << pro.tnet.mnets[i].nconn[j].sprob.val << " (" << pro.tnet.mnets[i].nconn[j].sprob.var << ")" << endl;
				//nns << "Target Net = " << pro.tnet.mnets[i].nconn[j].tnet << endl;
				//nns << "Target Pop = " << pro.tnet.mnets[i].nconn[j].tpop << endl;
				//nns << "Target Prob = " << pro.tnet.mnets[i].nconn[j].tprob.val << " (" << pro.tnet.mnets[i].nconn[j].tprob.var << ")" << endl;
				//nns << "Weight = " << pro.tnet.mnets[i].nconn[j].w.val << " (" << pro.tnet.mnets[i].nconn[j].w.var << ")" << endl;
				//nns << "</NCONN " << j << ">" << endl;
				nns << "[" << pro.tnet.mnets[i].nconn[j].optmz_OnOff << ";" << pro.tnet.mnets[i].nconn[j].norm_OnOff << ";" << pro.tnet.nets[i].pconn[j].syntype << ";" << pro.tnet.nets[pro.tnet.mnets[i].nconn[j].snet].name << ":" << pro.pops[pro.tnet.mnets[i].nconn[j].sid].name << ";" << pro.tnet.nets[pro.tnet.mnets[i].nconn[j].tnet].name << ":" << pro.pops[pro.tnet.mnets[i].nconn[j].tid].name << ";" << pro.tnet.mnets[i].nconn[j].sprob.val << "(" << pro.tnet.mnets[i].nconn[j].sprob.var << ")" << ";" << pro.tnet.mnets[i].nconn[j].tprob.val << "(" << pro.tnet.mnets[i].nconn[j].tprob.var << ")" << ";" << pro.tnet.mnets[i].nconn[j].w.val << "(" << pro.tnet.mnets[i].nconn[j].w.var << ")" << "]" << endl;
			};

			nns << "</MNET " << i << ">" << endl;
			nns << endl;

		};

		nns << "</NETWORKS>" << endl;
		nns << endl;

		nns << "<IODATA>" << endl;
		//nns << "N of IOData = " << pro.iodata.size() << endl;
		nns << endl;

		if (pro.iodata.size() != 0) {	
			for (int i = 0;i < (int)pro.iodata.size();i++) {
				//nns << "<DATA " << i << ">" << endl;
				//nns << "Name = " << pro.iodata[i].name << endl;
				//nns << "Type = " << pro.iodata[i].type << endl;
				//nns << "CMDLine = " << pro.iodata[i].cmdline << endl;
				//nns << "</DATA " << i << ">" << endl;
				nns << "[" << pro.iodata[i].name << "; " << pro.iodata[i].type << "; " << pro.iodata[i].cmdline << "]" << endl;
			};		
		};
		nns << "</IODATA>" << endl;
		nns << endl;

		nns << "//IODATA command Syntax:" << endl;
		nns << "//[Name; IODataTypeNumber; command line]" << endl;
		nns << endl;
		nns << "//IOData Type Number Definitions" << endl;
		nns << "//  0: IONSI Pump current" << endl;
		nns << "//  1: IONSI Channel current" << endl;
		nns << "//  4: IONSE Reversal potential" << endl;
		nns << "//  5: IONSE Concentration of inside ion" << endl;
		nns << "//  6: IONSE Concentration of outside ion" << endl;
		nns << "//  9: CHANG Channel conductance" << endl;
		nns << "// 10: CHANG Channel current" << endl;
		nns << "// 12: CHANMH Channel activation" << endl;
		nns << "// 14: CHANMH Channel inactivation" << endl;
		nns << "// 16: CELLV Membrane potential" << endl;
		nns << "// 18: CELLV Spikes onset" << endl;
		nns << "// 19: CELLV Injected current" << endl;
		nns << endl;

		nns << "//Command line syntax:" << endl;
		nns << "//for poulation selection, p[]" << endl;
		nns << "//for neuron selection, n[]" << endl;
		nns << "//for channel or ion selection, c[]" << endl;
		nns << "//Various selection methods, ALL, [all], [0,2], [0:3], [0,4:5,9] etc." << endl;
		nns << "//for view option, /v" << endl;
		nns << "//for save option, /s" << endl;

		nns << "//ie. [Spikes; 18; ALL /v/s]" << endl;
		nns << "//ie. [Cin; 5; p[all] n[0,2:4,9] c[0] /v/s]" << endl;
		nns << endl;

		nns.close();
	};

	cout <<"NNS file was saved as "<<fname<<endl;

};

int load_nns(string fname,nns_project& pro) {
	int res;
	int nline=0;
	string line;
	vector<string> nns;
	ifstream nnsfile (fname);
	if (nnsfile.is_open())
	{
		while(getline(nnsfile,line))
		{
			nns.push_back(line);
			++nline;
		}
		nnsfile.close();
		nns = rmblanklines(nns);
		nns = rmcomments(nns);
		res = parse_nns(nns,pro);
		return 1;
	} else
	{
		cout<<"ERROR:: unable to open "<<fname;
	};

	return 0;
};

//int load_nns(string fname,vector<neural_population>& pops,vector<nns_net>& nets, vector<nns_mnet>& mnets) {
//	int nline=0;
//	string line;
//	vector<string> nns;
//	ifstream nnsfile (fname);
//	if (nnsfile.is_open())
//	{
//		while(getline(nnsfile,line))
//		{
//			nns.push_back(line);
//			++nline;
//		}
//		nnsfile.close();
//		//res = parse_nns(nns,pops,nets,mnets);
//		//if (res == 1) return 1;
//	} else
//	{
//		cout<<"ERROR:: unable to open "<<fname;
//	};
//
//	return 0;
//};

//int parse_nns(vector<string>& nns,vector<neural_population>& pops,vector<nns_net>& nets,vector<nns_mnet>& mnets) {
int parse_nns(vector<string>& nns, nns_project& pro) {

	vector<int> lid1;
	vector<int> lid2;
	vector<int> lid3;
	vector<int> popid;
	vector<int> neuid;
	vector<int> netid;
	vector<int> mnetid;
	vector<int> chid;
	vector<int> ionid;
	vector<int> iodid;
	vector<int> synid;
	vector<int> synpid;
	vector<int> drvid;
	vector<int> outid;
	vector<int> nsuid;
// SM	int lid;
	string lkey;
	string tmp;

	stringstream tmpstr;
	//int sid, sid2;
	int npops=0;
	int nnets=0;
	int nmnets=0;
	int nsynps = 0;

	lkey = "CTR PARAM";
	lid1.clear();
	lid1 = findh(nns, lkey);

	lkey = "Seed";
	//pro.pops[ip].paraset.ctr_para.seed = (unsigned int) (exti(nns,lid1[0],lid1[1],lkey));
	pro.ctr_para.seed = (unsigned int)(exti(nns, lid1[0], lid1[1], lkey));
	lkey = "SimStep";
	//pro.pops[ip].paraset.ctr_para.simstep = extd(nns,lid1[0],lid1[1],lkey);
	pro.ctr_para.simstep = extd(nns, lid1[0], lid1[1], lkey);
	lkey = "SimDuration";
	//pro.pops[ip].paraset.ctr_para.simduration = extd(nns,lid1[0],lid1[1],lkey);
	pro.ctr_para.simduration = extd(nns, lid1[0], lid1[1], lkey);

	pro.ctr_para.threshold = -35; //default threshold. 4.5.2016

	lkey = "N of SynapseType ";
	nsynps = exti(nns, lkey);

	lkey = "SYNAPSE ";
	synpid = findh(nns, lkey);

	lkey = "N of Pops";
	npops = exti(nns,lkey);

	synp_parameters syn_para;
	for (int tt = 0;tt < 2;tt++) {
		for (int isp = 0; isp < nsynps; isp++) { //Making 8 synapse channels for NSUs
			lkey = "SYNP ";
			synid.clear();
			synid = findh(nns, synpid[0], synpid[1], lkey, isp);

			lkey = "Name ";
			syn_para.name = exts(nns, synid[0], synid[1], lkey);
			lkey = "IonType ";
			syn_para.IonType = exti(nns, synid[0], synid[1], lkey);

			lkey = "Gm ";
			syn_para.g = extp(nns, synid[0], synid[1], lkey);
			lkey = "E ";
			syn_para.E = extp(nns, synid[0], synid[1], lkey);
			lkey = "Tc ";
			syn_para.Tc = extd(nns, synid[0], synid[1], lkey);
			lkey = "Amp ";
			syn_para.Amp = extd(nns, synid[0], synid[1], lkey);

			pro.syn_para.push_back(syn_para);

		};
	};

	for (int ip=0;ip<npops;ip++)
	{
		neural_population pop;
		//pop = new neural_population;

		lkey = "POP ";
		popid.clear();
		popid = findh(nns,lkey,ip);

		lkey = "NEURON PARAM";
		neuid.clear();
		neuid = findh(nns,popid[0],popid[1],lkey);

		lkey = "Name";
		pop.name = exts(nns,popid[0],neuid[0],lkey);
		lkey = "ID";
		pop.ID = exti(nns,popid[0],neuid[0],lkey);
		lkey = "Size";
		pop.nneurons = exti(nns,popid[0],neuid[0],lkey);
		lkey = "Threshold";
		pop.threshold = extd(nns,popid[0],neuid[0],lkey);

		pro.pops.push_back(pop);

		lkey = "Cm";
		pro.pops[ip].paraset.neu_para.Cm= extp(nns,neuid[0],neuid[1],lkey);
		lkey = "Vm";
		pro.pops[ip].paraset.neu_para.Vm= extp(nns,neuid[0],neuid[1],lkey);
		lkey = "Area";
		pro.pops[ip].paraset.neu_para.area = extd(nns, neuid[0], neuid[1], lkey);
		lkey = "Type ";
		pro.pops[ip].paraset.neu_para.neuT = exti(nns,neuid[0],neuid[1],lkey);

		lkey = "ICHANNELS PARAM";
		lid1.clear();
		lid1 = findlvw(nns,popid[0],popid[1],lkey);

		int nIChs;
		vector<int> IChGTList;
		vector<string> IChNList;
		vector<int> IChMHTList;
		vector<int> IChITList;
		vector<int> IChDSList;

		//lkey = "<ICH 0>";
		//lid = findlw(nns,lid1[0],lid1[1],lkey);
		//lid2.clear();
		//lid2 = lid1;
		//lid1[1] = lid;

		lkey = "nICH ";
		nIChs = exti(nns,lid1[0],lid1[1],lkey);

		lkey = "nICHNameList";
		IChNList.clear();
		IChNList = extls(nns, lid1[0], lid1[1], lkey, nIChs);

		lkey = "nICHGTypeList";
		IChGTList.clear();
		IChGTList = extli(nns,lid1[0],lid1[1],lkey, nIChs);

		lkey = "nICHMHTypeList";
		IChMHTList.clear();
		IChMHTList = extli(nns, lid1[0], lid1[1], lkey, nIChs);

		lkey = "nICHITypeList";
		IChITList.clear();
		IChITList = extli(nns, lid1[0], lid1[1], lkey, nIChs);

		lkey = "nICHDStatusList";
		IChDSList.clear();
		IChDSList = extli(nns, lid1[0], lid1[1], lkey, nIChs);

		//lkey = "ICHANNELS PARAM";
		//lid1.clear();
		//lid1 = findlvw(nns,popid[0],popid[1],lkey);
		
		//This part is to add 4 default channels for SynpE1, SynpE2, SynpI1, SynpI2
		// before creating other channels. 11.9.2015
		string nm;
		int iont;
		//for (int isp = 0; isp < nsynps; isp++) {
		
		for (int tt = 0;tt < 2;tt++) {
			for (int isp = 0; isp < nsynps; isp++) { //Making 8 synapse channels for NSUs
				lkey = "SYNP ";
				synid.clear();
				synid = findh(nns, synpid[0], synpid[1], lkey, isp);

				lkey = "Name ";
				nm = exts(nns, synid[0], synid[1], lkey);
				lkey = "IonType ";
				iont = exti(nns, synid[0], synid[1], lkey);

				create_ich(pro.pops, ip, nm, 13, 1, iont, 0);
				lkey = "Gm ";
				pro.pops[ip].paraset.ichs.ng_para[isp + tt*nsynps].g = extp(nns, synid[0], synid[1], lkey);
				lkey = "E ";
				pro.pops[ip].paraset.ichs.ng_para[isp + tt*nsynps].E = extp(nns, synid[0], synid[1], lkey);
				lkey = "Tc ";
				pro.pops[ip].paraset.ichs.ng_para[isp + tt*nsynps].Tc = extd(nns, synid[0], synid[1], lkey);
				lkey = "Amp ";
				pro.pops[ip].paraset.ichs.ng_para[isp + tt*nsynps].Amp = extd(nns, synid[0], synid[1], lkey);
				
		    
			};
		};

		
		//int cg = 0, cab = 0, cz = 0, cn = nsynps;
		int cg = 0, cab = 0, cz = 0, cn = nsynps * 2; // modified on 21.21.2015

		//int cg=0,cab=0,cz=0,cn=0;
		for (int j=0;j<nIChs;j++) 
		{
			create_ich(pro.pops, ip, IChNList[j], IChGTList[j], IChMHTList[j], IChITList[j], IChDSList[j]);

			lkey = "ICH ";
			chid = findh(nns,popid[0],popid[1],lkey,j);

			if (chid.size() > 0) {
				switch (IChGTList[j])
				{
				case 2: case 3: case 4: case 5:

					lkey = "g ";
					pro.pops[ip].paraset.ichs.g_para[cg].g = extp(nns, chid[0], chid[1], lkey);
					lkey = "E ";
					pro.pops[ip].paraset.ichs.g_para[cg].E = extp(nns, chid[0], chid[1], lkey);
					lkey = "mpower";
					pro.pops[ip].paraset.ichs.g_para[cg].mpower = exti(nns, chid[0], chid[1], lkey);
					lkey = "hpower";
					pro.pops[ip].paraset.ichs.g_para[cg].hpower = exti(nns, chid[0], chid[1], lkey);
					lkey = "M0";
					pro.pops[ip].paraset.ichs.g_para[cg].M0 = extd(nns, chid[0], chid[1], lkey);
					lkey = "H0";
					pro.pops[ip].paraset.ichs.g_para[cg].H0 = extd(nns, chid[0], chid[1], lkey);

					lkey = "t0m";
					pro.pops[ip].paraset.ichs.g_para[cg].t0m = extd(nns, chid[0], chid[1], lkey);
					lkey = "t0h";
					pro.pops[ip].paraset.ichs.g_para[cg].t0h = extd(nns, chid[0], chid[1], lkey);
					lkey = "tm ";
					pro.pops[ip].paraset.ichs.g_para[cg].tm = extp(nns, chid[0], chid[1], lkey);
					lkey = "th ";
					pro.pops[ip].paraset.ichs.g_para[cg].th = extp(nns, chid[0], chid[1], lkey);

					lkey = "V12m ";
					pro.pops[ip].paraset.ichs.g_para[cg].Vsm = extp(nns, chid[0], chid[1], lkey);
					lkey = "V12tm ";
					pro.pops[ip].paraset.ichs.g_para[cg].Vhfm = extp(nns, chid[0], chid[1], lkey);
					lkey = "V12tm2 ";
					pro.pops[ip].paraset.ichs.g_para[cg].Vhfm2 = extp(nns, chid[0], chid[1], lkey);
					lkey = "km ";
					pro.pops[ip].paraset.ichs.g_para[cg].km = extp(nns, chid[0], chid[1], lkey);
					lkey = "ktm ";
					pro.pops[ip].paraset.ichs.g_para[cg].ktm = extp(nns, chid[0], chid[1], lkey);
					lkey = "ktm2 ";
					pro.pops[ip].paraset.ichs.g_para[cg].ktm2 = extp(nns, chid[0], chid[1], lkey);

					lkey = "V12h ";
					pro.pops[ip].paraset.ichs.g_para[cg].Vsh = extp(nns, chid[0], chid[1], lkey);
					lkey = "V12th ";
					pro.pops[ip].paraset.ichs.g_para[cg].Vhfh = extp(nns, chid[0], chid[1], lkey);
					lkey = "V12th2 ";
					pro.pops[ip].paraset.ichs.g_para[cg].Vhfh2 = extp(nns, chid[0], chid[1], lkey);
					lkey = "kh ";
					pro.pops[ip].paraset.ichs.g_para[cg].kh = extp(nns, chid[0], chid[1], lkey);
					lkey = "kth ";
					pro.pops[ip].paraset.ichs.g_para[cg].kth = extp(nns, chid[0], chid[1], lkey);
					lkey = "kth2 ";
					pro.pops[ip].paraset.ichs.g_para[cg].kth2 = extp(nns, chid[0], chid[1], lkey);

					cg++;
					break;
				case 6: case 7:

					lkey = "g ";
					pro.pops[ip].paraset.ichs.ab_para[cab].g = extp(nns, chid[0], chid[1], lkey);
					lkey = "E ";
					pro.pops[ip].paraset.ichs.ab_para[cab].E = extp(nns, chid[0], chid[1], lkey);
					lkey = "mpower";
					pro.pops[ip].paraset.ichs.ab_para[cab].mpower = exti(nns, chid[0], chid[1], lkey);
					lkey = "hpower";
					pro.pops[ip].paraset.ichs.ab_para[cab].hpower = exti(nns, chid[0], chid[1], lkey);
					lkey = "M0";
					pro.pops[ip].paraset.ichs.ab_para[cab].M0 = extd(nns, chid[0], chid[1], lkey);
					lkey = "H0";
					pro.pops[ip].paraset.ichs.ab_para[cab].H0 = extd(nns, chid[0], chid[1], lkey);
					lkey = "t0m";
					pro.pops[ip].paraset.ichs.ab_para[cab].t0m = extd(nns, chid[0], chid[1], lkey);
					lkey = "tm";
					pro.pops[ip].paraset.ichs.ab_para[cab].tmaxm = extd(nns, chid[0], chid[1], lkey);
					lkey = "t0h";
					pro.pops[ip].paraset.ichs.ab_para[cab].t0h = extd(nns, chid[0], chid[1], lkey);
					lkey = "th";
					pro.pops[ip].paraset.ichs.ab_para[cab].tmaxh = extd(nns, chid[0], chid[1], lkey);

					lkey = "MAa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MAa = extp(nns, chid[0], chid[1], lkey);
					lkey = "MBa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MBa = extp(nns, chid[0], chid[1], lkey);
					lkey = "MCa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MCa = extp(nns, chid[0], chid[1], lkey);
					lkey = "MDa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MDa = extp(nns, chid[0], chid[1], lkey);
					lkey = "MEa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MEa = extp(nns, chid[0], chid[1], lkey);

					lkey = "MAb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MAb = extp(nns, chid[0], chid[1], lkey);
					lkey = "MBb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MBb = extp(nns, chid[0], chid[1], lkey);
					lkey = "MCb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MCb = extp(nns, chid[0], chid[1], lkey);
					lkey = "MDb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MDb = extp(nns, chid[0], chid[1], lkey);
					lkey = "MEb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].MEb = extp(nns, chid[0], chid[1], lkey);

					lkey = "HAa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HAa = extp(nns, chid[0], chid[1], lkey);
					lkey = "HBa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HBa = extp(nns, chid[0], chid[1], lkey);
					lkey = "HCa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HCa = extp(nns, chid[0], chid[1], lkey);
					lkey = "HDa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HDa = extp(nns, chid[0], chid[1], lkey);
					lkey = "HEa ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HEa = extp(nns, chid[0], chid[1], lkey);

					lkey = "HAb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HAb = extp(nns, chid[0], chid[1], lkey);
					lkey = "HBb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HBb = extp(nns, chid[0], chid[1], lkey);
					lkey = "HCb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HCb = extp(nns, chid[0], chid[1], lkey);
					lkey = "HDb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HDb = extp(nns, chid[0], chid[1], lkey);
					lkey = "HEb ";
					pro.pops[ip].paraset.ichs.ab_para[cab].HEb = extp(nns, chid[0], chid[1], lkey);

					cab++;
					break;
				case 8: case 9: case 10: case 11:

					lkey = "g ";
					pro.pops[ip].paraset.ichs.z_para[cz].g = extp(nns, chid[0], chid[1], lkey);
					lkey = "E ";
					pro.pops[ip].paraset.ichs.z_para[cz].E = extp(nns, chid[0], chid[1], lkey);
					lkey = "mpower";
					pro.pops[ip].paraset.ichs.z_para[cz].mpower = exti(nns, chid[0], chid[1], lkey);
					lkey = "hpower";
					pro.pops[ip].paraset.ichs.z_para[cz].hpower = exti(nns, chid[0], chid[1], lkey);

					lkey = "M0";
					pro.pops[ip].paraset.ichs.z_para[cz].M0 = extd(nns, chid[0], chid[1], lkey);
					lkey = "H0";
					pro.pops[ip].paraset.ichs.z_para[cz].H0 = extd(nns, chid[0], chid[1], lkey);

					lkey = "t0";
					pro.pops[ip].paraset.ichs.z_para[cz].t0 = extd(nns, chid[0], chid[1], lkey);
					lkey = "tmax";
					pro.pops[ip].paraset.ichs.z_para[cz].tmax = extd(nns, chid[0], chid[1], lkey);

					lkey = "A ";
					pro.pops[ip].paraset.ichs.z_para[cz].A = extp(nns, chid[0], chid[1], lkey);
					lkey = "B ";
					pro.pops[ip].paraset.ichs.z_para[cz].B = extp(nns, chid[0], chid[1], lkey);
					lkey = "L ";
					pro.pops[ip].paraset.ichs.z_para[cz].L = extp(nns, chid[0], chid[1], lkey);
					lkey = "G ";
					pro.pops[ip].paraset.ichs.z_para[cz].G = extp(nns, chid[0], chid[1], lkey);
					lkey = "Vhf ";
					pro.pops[ip].paraset.ichs.z_para[cz].Vhf = extp(nns, chid[0], chid[1], lkey);
					lkey = "slp ";
					pro.pops[ip].paraset.ichs.z_para[cz].slp = extp(nns, chid[0], chid[1], lkey);

					cz++;
					break;
				case 0: case 12:

					lkey = "g ";
					pro.pops[ip].paraset.ichs.ng_para[cn].g = extp(nns, chid[0], chid[1], lkey);
					lkey = "E ";
					pro.pops[ip].paraset.ichs.ng_para[cn].E = extp(nns, chid[0], chid[1], lkey);

					cn++;
					break;

				};
			}
			else {
				cout << "ERROR::Channel [" << j << "] prameters: not found or missing tag" << endl;
			};
				
		}; //chs for

		int nIons, type;

		lkey = "IONS PARAM";
		lid1.clear();
		lid1 = findlvw(nns,popid[0],popid[1],lkey);

		if (lid1.size() > 0) {

			lkey = "nIONS ";
			nIons = exti(nns, lid1[0], lid1[1], lkey);

			for (int j = 0;j < nIons;j++)
			{
				lkey = "ION ";
				ionid = findh(nns, popid[0], popid[1], lkey, j);

				if (ionid.size() > 0) {

					lkey = "Name ";
					tmp = exts(nns, ionid[0], ionid[1], lkey);
					lkey = "IonType ";
					type = exti(nns, ionid[0], ionid[1], lkey);
					create_ion(pro.pops, ip, tmp, type);

					lkey = "ID ";
					pro.pops[ip].paraset.ions.ion_para[j].ID = exti(nns, ionid[0], ionid[1], lkey);
					lkey = "PumpType ";
					pro.pops[ip].paraset.ions.ion_para[j].pumpType = exti(nns, ionid[0], ionid[1], lkey);
					lkey = "Cin ";
					pro.pops[ip].paraset.ions.ion_para[j].Cin = extd(nns, ionid[0], ionid[1], lkey);
					lkey = "Cout ";
					pro.pops[ip].paraset.ions.ion_para[j].Cout = extd(nns, ionid[0], ionid[1], lkey);
					//lkey = "E ";
					//pro.pops[ip].paraset.ions.ion_para[j].E = extd(nns,ionid[0],ionid[1],lkey);
					//lkey = "R ";
					//pro.pops[ip].paraset.ions.ion_para[j].R = extd(nns,ionid[0],ionid[1],lkey);
					//lkey = "F ";
					//pro.pops[ip].paraset.ions.ion_para[j].F = extd(nns,ionid[0],ionid[1],lkey);
					//lkey = "T ";
					//pro.pops[ip].paraset.ions.ion_para[j].T = extd(nns,ionid[0],ionid[1],lkey);
					lkey = "Z ";
					pro.pops[ip].paraset.ions.ion_para[j].Z = extd(nns, ionid[0], ionid[1], lkey);
					lkey = "InEq ";
					pro.pops[ip].paraset.ions.ion_para[j].InEq = extd(nns, ionid[0], ionid[1], lkey);
					lkey = "t ";
					pro.pops[ip].paraset.ions.ion_para[j].t = extd(nns, ionid[0], ionid[1], lkey);
					lkey = "Rpmp ";
					pro.pops[ip].paraset.ions.ion_para[j].Rpmp = extd(nns, ionid[0], ionid[1], lkey);
					lkey = "Rch ";
					pro.pops[ip].paraset.ions.ion_para[j].Rch = extd(nns, ionid[0], ionid[1], lkey);
					lkey = "Kp ";
					pro.pops[ip].paraset.ions.ion_para[j].Kp = extd(nns, ionid[0], ionid[1], lkey);
					lkey = "K ";
					pro.pops[ip].paraset.ions.ion_para[j].K = extd(nns, ionid[0], ionid[1], lkey);
					lkey = "B ";
					pro.pops[ip].paraset.ions.ion_para[j].B = extd(nns, ionid[0], ionid[1], lkey);

				}
				else {
					cout << "ERROR::ION [" << j << "] prameters: not found or missing tag" << endl;
				}
			}; //ion for
		};

	}; //pop for

	//NSUs (Non Spike Units) start ==========================
	lkey = "NSUNITS";
	nsuid.clear();
	nsuid = findh(nns, lkey);
	size_t ndrv;

	if (nsuid.size() > 0) {

		lkey = "DRIVES";
		drvid.clear();
		drvid = findh(nns, lkey);

		if (drvid.size() > 0) {
			lkey = "[";
			lid1.clear();
			lid1 = findh(nns, drvid[0], drvid[1], lkey);
			ndrv = lid1.size();
			for (size_t d = 0;d < ndrv;d++) {
				string temp = nns[lid1[d]];
				string name = extsc(temp, 0);
				create_nsuc(pro.nsu, name, NSU_DRIVE);
			};
		};

		lkey = "OUTPUTS";
		outid.clear();
		outid = findh(nns, lkey);

		if (outid.size() > 0) {
			lkey = "[";
			lid1.clear();
			lid1 = findh(nns, outid[0], outid[1], lkey);
			for (size_t d = 0;d < lid1.size();d++) {
				string temp = nns[lid1[d]];
				string name = extsc(temp, 0);

				create_nsuc(pro.nsu, name, NSU_OUTPUT);
				pro.nsu.units[d+ndrv].Tup = extdc(temp, 1);
				pro.nsu.units[d+ndrv].Tdown = extdc(temp, 2);
				pro.nsu.units[d+ndrv].Threshold = extdc(temp, 3);

				for (int tt = 0; tt < 2; tt++) {
					for (int isp = 0; isp < nsynps; isp++) { //Making 8 synapse channels for NSUs
					//for (int isp = 0; isp < nsynps; isp++) {
						lkey = "SYNP ";
						synid.clear();
						synid = findh(nns, synpid[0], synpid[1], lkey, isp);

						lkey = "Name ";
						pro.nsu.units[d + ndrv].ichs.ng_para[isp + tt*nsynps].name = exts(nns, synid[0], synid[1], lkey);
						lkey = "IonType ";
						pro.nsu.units[d + ndrv].ichs.ng_para[isp + tt*nsynps].Itype = exti(nns, synid[0], synid[1], lkey);

						lkey = "Gm ";
						pro.nsu.units[d + ndrv].ichs.ng_para[isp + tt*nsynps].g = extp(nns, synid[0], synid[1], lkey);
						lkey = "E ";
						pro.nsu.units[d + ndrv].ichs.ng_para[isp + tt*nsynps].E = extp(nns, synid[0], synid[1], lkey);
						lkey = "Tc ";
						pro.nsu.units[d + ndrv].ichs.ng_para[isp + tt*nsynps].Tc = extd(nns, synid[0], synid[1], lkey);
						lkey = "Amp ";
						pro.nsu.units[d + ndrv].ichs.ng_para[isp + tt*nsynps].Amp = extd(nns, synid[0], synid[1], lkey);
					};
				};

			};
		};

	};
	//NSUs (Non Spike Units) end ===============================

	//Network start ===========================================
	lkey = "NETWORKS";
	netid.clear();
	netid = findh(nns, lkey);

	if (!netid.empty()) {

		string nname, mname, temp, temp2, spname, tpname, snname, tnname;
		vector<string> pnameList;
		vector<string> unameList;
		vector<string> nnameList;
		vector<int> nidList;
		//int nList;
		int syntype, sw, stype, ttype, opt;
		bool optmz_OnOff, norm_OnOff;
		param sprob, tprob, w;

		//lkey = "Optimization";
		//pro.tnet.Optima = (bool) exti(nns, lkey);

		lkey = "N of Nets";
		nnets = exti(nns, lkey);

		for (int in = 0;in < nnets;in++) {
			lkey = "NET ";
			netid.clear();
			netid = findh(nns, lkey, in);
			if (netid.size() > 0) {
				lkey = "Name";
				nname = exts(nns, netid[0], netid[1], lkey);
				lkey = "OnOff";
				int OnOff = exti(nns, netid[0], netid[1], lkey);
				lkey = "pnameList";
				pnameList = extls(nns, netid[0], netid[1], lkey);
				lkey = "unameList";
				unameList = extls(nns, netid[0], netid[1], lkey);

				make_net(nname, pnameList, unameList, pro.pops, pro.nsu, pro.tnet.nets);
				int nidx = find_id(pro.tnet.nets, nname);
				pro.tnet.nets[nidx].OnOff = ( OnOff != 0 )? true: false;

				lkey = "[";
				lid1.clear();
				lid1 = findh(nns, netid[0], netid[1], lkey);

				for (size_t ic = 0;ic < lid1.size();ic++) {

					temp = nns[lid1[ic]];
					size_t idx = temp.find("&p");
					if (idx != std::string::npos) { //Plasticity
						size_t idx2 = temp.find("&*");
						if (idx2 != std::string::npos) { //All to all connections
							sw = CONN_ALLP;
						}
						else {
							idx2 = temp.find("&n");
							if (idx2 != std::string::npos) { //one to one connections
								sw = CONN_ONEP;
							}
						};
					}
					else { //Non-plasticity
						size_t idx2 = temp.find("&*");
						if (idx2 != std::string::npos) { //All to all connections
							sw = CONN_ALL;
						}
						else {
							idx2 = temp.find("&n");
							if (idx2 != std::string::npos) { //one to one connections
								sw = CONN_ONE;
							}
							else {
								sw = CONN_REG;
							};
						};
					};

					optmz_OnOff = bool(extic(temp, 0) != 0);
					norm_OnOff = bool(extic(temp, 1) != 0);
					syntype = extic(temp, 2);
					spname = extsc(temp, 3);
					stype = getrmtype(spname);
					tpname = extsc(temp, 4);
					ttype = getrmtype(tpname);
					
					int tprate=0;
					switch (sw) {
					case CONN_ALL:
						opt = CONN_ALL;
						w = extpc(temp, 5);
						conn_pops(nname, syntype, opt, spname, tpname, stype, ttype, w, tprate, optmz_OnOff, norm_OnOff, pro.nsu, pro.tnet.nets);
						break;
					case CONN_ONE:
						opt = CONN_ONE;
						w = extpc(temp, 5);
						conn_pops(nname, syntype, opt, spname, tpname, stype, ttype, w, tprate, optmz_OnOff, norm_OnOff, pro.nsu, pro.tnet.nets);
						break;
					case CONN_ALLP:
						opt = CONN_ALLP;
						w = extpc(temp, 5);
						tprate = extic(temp, 6);
						conn_pops(nname, syntype, opt, spname, tpname, stype, ttype, w, tprate, optmz_OnOff, norm_OnOff, pro.nsu, pro.tnet.nets);
						break;
					case CONN_ONEP:
						opt = CONN_ONEP;
						w = extpc(temp, 5);
						tprate = extic(temp, 6);
						conn_pops(nname, syntype, opt, spname, tpname, stype, ttype, w, tprate, optmz_OnOff, norm_OnOff, pro.nsu, pro.tnet.nets);
						break;
					case CONN_REG:
						opt = CONN_REG;
						sprob = tprob = extpc(temp, 5);
						w = extpc(temp, 6);

						//The following is for separate probability setting between source and target
						//sprob = extpc(temp, 4);
						//tprob = extpc(temp, 5);
						//w = extpc(temp, 6);
						conn_pops(nname, syntype, opt, spname, tpname, stype, ttype, sprob, tprob, w, optmz_OnOff, norm_OnOff, pro.nsu, pro.tnet.nets);
						break;
					};
				};
			}
			else {
				cout << "ERROR::NET [" << in << "] prameters: not found or missing tag" << endl;
			};
		};

		lkey = "N of MNets";
		nmnets = exti(nns, lkey);

		for (int im = 0;im < nmnets;im++) {

			lkey = "MNET ";
			mnetid = findh(nns, lkey, im);

			if (mnetid.size() > 0) {
				lkey = "Name";
				mname = exts(nns, mnetid[0], mnetid[1], lkey);
				lkey = "nnameList";
				nnameList = extls(nns, mnetid[0], mnetid[1], lkey);

				make_mnet(mname, nnameList, pro.pops, pro.tnet.nets, pro.tnet.mnets);

				lkey = "[";
				lid1.clear();
				lid1 = findh(nns, mnetid[0], mnetid[1], lkey);

				for (size_t ic = 0;ic < lid1.size();ic++) {

					temp = nns[lid1[ic]];
					syntype = extic(temp, 0);
					temp2 = extsc(temp, 1);
					lkey = ":";
					size_t cid = temp2.find(lkey);
					snname = temp2.substr(0, cid);
					spname = temp2.substr(cid + 1, temp2.size());
					temp2 = extsc(temp, 2);
					lkey = ":";
					cid = temp2.find(lkey);
					tnname = temp2.substr(0, cid);
					tpname = temp2.substr(cid + 1, temp2.size());
					sprob = extpc(temp, 3);
					tprob = extpc(temp, 4);
					w = extpc(temp, 5);

					conn_nets(mname, syntype, snname, tnname, spname, tpname, sprob, tprob, w, pro.tnet.nets, pro.tnet.mnets);

				};
			}
			else {
				cout << "ERROR::MNET [" << im << "] prameters: not found or missing tag" << endl;
			};

		};
	};
	//Network end ===========================================

	//IOData start ===========================================================

	lkey = "IODATA";
	iodid.clear();
	iodid = findh(nns, lkey);

	if (iodid.size() > 0) {
		string temp, name, cmdline;
		int type;
		lid1.clear();
		lkey = "[";
		lid1 = findh(nns, iodid[0], iodid[1], lkey);
		if (!lid1.empty()) {
			for (size_t id = 0;id < lid1.size();id++) {

				temp = nns[lid1[id]];
				name = extsc(temp, 0);
				type = extic(temp, 1);
				cmdline = extsc(temp, 2);

				create_iodata(name, type, cmdline, pro);
			};
		}
		else {
			cout << "WARNING::IOData Setting: required!" << endl;
		};
	};

	//IOData end ===========================================================


	return 0;
};

string extsc(string str, int n) {
	string key,tmpstr;
	size_t tid,tid2;
	int sid[20] = { -1 };
	int nn = 0, nsc = 0, flg = 0;

	str = rmspaces(str);
	key = "[";
	tid = str.find(key);
	str.erase(tid,1);
	key = "]";
	tid = str.find(key);
	tid2 = str.find(key, tid + 1);
	while (tid2 != std::string::npos) {
		tid = tid2;
		tid2 = str.find(key, tid + 1);
	};
	str.erase(tid, str.size() - tid);
	//Finding the number of semicolons
	key = ";";
	size_t scid = str.find(key);
	if (scid == std::string::npos) nsc = 1;
	else {
		nsc++;
		while (flg == 0) {
			size_t scid2 = str.find(key, scid + 1);
			if (scid2 != std::string::npos) {
				nsc++;
				scid = scid2;
			}
			else
				flg = 1;
		};
	}
	nn = nsc + 1;
	key = ";";
	for (int i = 0;i < nn;i++) {
		if (i == 0)
			sid[i] = (int)str.find(key);
		else
			sid[i] = (int)str.find(key, sid[i - 1] + 1);
	};
	if (n == 0)
		tmpstr = str.substr(0, sid[n]);
	else
		tmpstr = str.substr(sid[n-1]+1, sid[n]-sid[n-1]-1);
	return tmpstr;
};

int extic(string str, int n) {
	string key, tmpstr;
	size_t tid, tid2;
	int sid[20] = { -1 };
	int nn = 0, nsc = 0, flg = 0;

	str = rmspaces(str);
	key = "[";
	tid = str.find(key);
	str.erase(tid, 1);
	key = "]";
	tid = str.find(key);
	tid2 = str.find(key, tid + 1);
	while (tid2 != std::string::npos) {
		tid = tid2;
		tid2 = str.find(key, tid + 1);
	};
	str.erase(tid, str.size()-tid);
	//Finding the number of semicolons
	key = ";";
	size_t scid = str.find(key);
	if (scid == std::string::npos) nsc = 1;
	else {
		nsc++;
		while (flg == 0) {
			size_t scid2 = str.find(key, scid + 1);
			if (scid2 != std::string::npos) {
				nsc++;
				scid = scid2;
			}
			else
				flg = 1;
		};
	}
	nn = nsc + 1;
	key = ";";
	for (int i = 0;i < nn;i++) {
		if (i == 0)
			sid[i] = (int)str.find(key);
		else
			sid[i] = (int)str.find(key, sid[i - 1] + 1);
	};
	if (n == 0)
		tmpstr = str.substr(0, sid[n]);
	else
		tmpstr = str.substr(sid[n - 1]+1, sid[n] - sid[n - 1] - 1);
	return stoi(tmpstr);
};

double extdc(string str, int n) {
	string key, tmpstr;
	size_t tid, tid2;
	int sid[20] = { -1 };
	int nn = 0, nsc = 0, flg = 0;

	str = rmspaces(str);
	key = "[";
	tid = str.find(key);
	str.erase(tid, 1);
	key = "]";
	tid = str.find(key);
	tid2 = str.find(key, tid + 1);
	while (tid2 != std::string::npos) {
		tid = tid2;
		tid2 = str.find(key, tid + 1);
	};
	str.erase(tid, str.size() - tid);
	//Finding the number of semicolons
	key = ";";
	size_t scid = str.find(key);
	if (scid == std::string::npos) nsc = 1;
	else {
		nsc++;
		while (flg == 0) {
			size_t scid2 = str.find(key, scid + 1);
			if (scid2 != std::string::npos) {
				nsc++;
				scid = scid2;
			}
			else
				flg = 1;
		};
	}
	nn = nsc + 1;
	key = ";";
	for (int i = 0;i < nn;i++) {
		if (i == 0)
			sid[i] = (int)str.find(key);
		else
			sid[i] = (int)str.find(key, sid[i - 1] + 1);
	};
	if (n == 0)
		tmpstr = str.substr(0, sid[n]);
	else
		tmpstr = str.substr(sid[n - 1] + 1, sid[n] - sid[n - 1] - 1);
	return stod(tmpstr);
};

param extpc(string str, int n) {
	param out;
	string key, tmpstr;
	size_t tid,tid2;
	int sid[20] = { -1 };
	int nn = 0, nsc = 0, flg = 0;

	str = rmspaces(str);
	key = "[";
	tid = str.find(key);
	str.erase(tid, 1);
	key = "]";
	tid = str.find(key);
	str.erase(tid, str.size() - tid);
	//Finding the number of semicolons
	key = ";";
	size_t scid = str.find(key);
	if (scid == std::string::npos) nsc = 1;
	else {
		nsc++;
		while (flg == 0) {
			size_t scid2 = str.find(key, scid + 1);
			if (scid2 != std::string::npos) {
				nsc++;
				scid = scid2;
			}
			else
				flg = 1;
		};
	}
	nn = nsc + 1;
	key = ";";
	for (int i = 0;i < nn;i++) {
		if (i == 0)
			sid[i] = (int)str.find(key);
		else
			sid[i] = (int)str.find(key, sid[i - 1] + 1);
	};
	if (n == 0)
		tmpstr = str.substr(0, sid[n]);
	else
		tmpstr = str.substr(sid[n - 1] + 1, sid[n] - sid[n - 1] - 1);
	key = "(";
	tid = tmpstr.find(key);
	if (tid == std::string::npos) { //If there is no variance value within ()
		out.val = stod(tmpstr);
		out.var = 0;
	}
	else {
		key = ")";
		tid2 = tmpstr.find(key);
		out.val = stod(tmpstr.substr(0, tid));
		out.var = stod(tmpstr.substr(tid+1,tid2-tid));
	}
	return out;
};

int exti(vector<string>& vstr,int ls,int le,string key){
	int lid;
	size_t sid, sid2;
	lid = findlw(vstr,ls,le,key);
	string str = vstr[lid];
	str = rmspaces(str);
	key = "=";
	sid = str.find(key);
	sid2 = str.length();
	return stoi(str.substr(sid+1,sid2-(sid+1)));
};
int exti(vector<string>& vstr,string key){
	int lid;
	size_t sid, sid2;
	lid = findl(vstr,key);
	string str = vstr[lid];
	str = rmspaces(str);
	key = "=";
	sid = str.find(key);
	sid2 = str.length();
	return stoi(str.substr(sid+1,sid2-(sid+1)));
};
double extd(vector<string>& vstr,int ls,int le,string key){
	int lid;
	size_t sid, sid2;
	lid = findlw(vstr,ls,le,key);
	string str = vstr[lid];
	str = rmspaces(str);
	key = "=";
	sid = str.find(key);
	sid2 = str.length();
	return stod(str.substr(sid+1,sid2-(sid+1)));
};

string exts(vector<string>& vstr,int ls,int le,string key){
	int lid;
	size_t sid, sid2;
	lid = findlw(vstr,ls,le,key);
	string str = vstr[lid];
	str = rmspaces(str);
	key = "=";
	sid = str.find(key);
	sid2 = str.length();
	return str.substr(sid+1,sid2-(sid+1));

};

param extp(vector<string>& vstr,int ls,int le,string key){
	param x; 
	int lid;
	size_t sid, sid2;

	lid = findlw(vstr,ls,le,key);
	string str = vstr[lid];
	str = rmspaces(str);
	key = "=";
	sid = str.find(key);
	key = "(";
	sid2 = str.find(key);
	x.val= stod(str.substr(sid+1,sid2-(sid+1)));
	sid = sid2;
	key = ")";
	sid2 = str.find(key);
	x.var= stod(str.substr(sid+1,sid2-(sid+1)));
	return x;
};

vector<int> extli(vector<string>& vstr,int ls,int le,string key,int n){
	vector<int> list; 
	int lid=-1;
	size_t sid, sid2; 
	string tmp, tmp2;

	lid = findlw(vstr,ls,le,key);
	key = "{";
	sid = vstr[lid].find(key);
	key = "}";
	sid2 = vstr[lid].find(key);
	tmp = vstr[lid].substr(sid+1,sid2-(sid+1));
	tmp = rmspaces(tmp);
	for (int j=0;j<n;j++) {
		if (j != n-1) {
			sid = 0;
			key = ",";
			sid2 = tmp.find(key);
			tmp2 = tmp.substr(sid,sid2-sid);
			list.push_back(stoi(tmp2));
			tmp = tmp.substr(sid2+1,tmp.length()-(sid2+1));
		}else {
			list.push_back(stoi(tmp));
		};
	};

	return list;
};

vector<int> extli(vector<string>& vstr, int ls, int le, string key) {
	vector<int> list;
	int lid = -1,n=0,nc=0,flg=0;
	size_t sid, sid2;
	string tmp, tmp2;

	lid = findlw(vstr, ls, le, key);
	key = "{";
	sid = vstr[lid].find(key);
	key = "}";
	sid2 = vstr[lid].find(key);
	tmp = vstr[lid].substr(sid + 1, sid2 - (sid + 1));
	tmp = rmspaces(tmp);
	//Finding the number of commas
	key = ",";
	sid = tmp.find(key);
	if (sid == std::string::npos) nc = 1;
	else {
		nc++;
		while (flg == 0) {
			sid2 = tmp.find(key, sid + 1);
			if (sid2 != std::string::npos) {
				nc++;
				sid = sid2;
			}
			else
				flg = 1;
		};
	}
	n = nc + 1;
	for (int j = 0;j<n;j++) {
		if (j != n - 1) {
			sid = 0;
			key = ",";
			sid2 = tmp.find(key);
			tmp2 = tmp.substr(sid, sid2 - sid);
			list.push_back(stoi(tmp2));
			tmp = tmp.substr(sid2 + 1, tmp.length() - (sid2 + 1));
		}
		else {
			list.push_back(stoi(tmp));
		};
	};

	return list;
};

vector<string> extls(vector<string>& vstr,int ls,int le,string key,int n){
	vector<string> list; 
	int lid=-1;
	size_t sid, sid2; 
	string tmp, tmp2;

	lid = findlw(vstr,ls,le,key);
	if (lid != -1) {
		key = "{";
		sid = vstr[lid].find(key);
		key = "}";
		sid2 = vstr[lid].find(key);
		tmp = vstr[lid].substr(sid + 1, sid2 - (sid + 1));
		tmp = rmspaces(tmp);

		for (int j = 0;j < n;j++) {
			if (j != n - 1) {
				sid = 0;
				key = ",";
				sid2 = tmp.find(key);
				tmp2 = tmp.substr(sid, sid2 - sid);
				list.push_back(tmp2);
				tmp = tmp.substr(sid2 + 1, tmp.length() - (sid2 + 1));
			}
			else {
				list.push_back(tmp);
			};
		};
	};

	return list;
};

vector<string> extls(vector<string>& vstr, int ls, int le, string key) {
	vector<string> list;
	int lid = -1, n=0, nc=0, flg=0;
	size_t sid, sid2;
	string tmp, tmp2;

	lid = findlw(vstr, ls, le, key);
	if (lid != -1) {
		key = "{";
		sid = vstr[lid].find(key);
		key = "}";
		sid2 = vstr[lid].find(key);
		tmp = vstr[lid].substr(sid + 1, sid2 - (sid + 1));
		tmp = rmspaces(tmp);
		//Finding the number of commas
		key = ",";
		sid = tmp.find(key);
		if (sid == std::string::npos) nc = 1;
		else {
			nc++;
			while (flg == 0) {
				sid2 = tmp.find(key, sid + 1);
				if (sid2 != std::string::npos) {
					nc++;
					sid = sid2;
				}
				else
					flg = 1;
			};
		}
		n = nc + 1;
		for (int j = 0;j < n;j++) {
			if (j != n - 1) {
				sid = 0;
				key = ",";
				sid2 = tmp.find(key);
				tmp2 = tmp.substr(sid, sid2 - sid);
				list.push_back(tmp2);
				tmp = tmp.substr(sid2 + 1, tmp.length() - (sid2 + 1));
			}
			else {
				list.push_back(tmp);
			};
		};
	};

	return list;
};

vector<int> findh(vector<string>& vstr,string key,int n) {
	stringstream tmpss;
	vector<int> idx;

	tmpss << key << n;
	key = tmpss.str();
	idx = findlv(vstr,key);

	return idx;
};

vector<int> findh(vector<string>& vstr,string key) {
	stringstream tmpss;
	vector<int> idx;
	idx = findlv(vstr,key);

	return idx;
};

vector<int> findh(vector<string>& vstr,int ls,int le,string key){
	stringstream tmpss;
	vector<int> idx;

	idx = findlvw(vstr,ls,le,key);

	return idx;
};

vector<int> findh(vector<string>& vstr,int ls, int le,string key,int n) {
	stringstream tmpss;
	vector<int> idx;

	tmpss << key << n;
	key = tmpss.str();
	idx = findlvw(vstr,ls,le,key);

	return idx;
};

//Find the line including string wd in a sting vector
vector<int> findlv(vector<string>& vstr,string wd) {
	vector<int> idx;
	size_t found;
	for (unsigned int i=0;i<vstr.size();i++)
	{
		found = vstr[i].find(wd);
		if (found != std::string::npos) {
				idx.push_back(i);
		};
	};
	return idx;
};

int findl(vector<string>& vstr,string wd) {
	int idx=-1;
	size_t found;
	for (unsigned int i = 0;i < vstr.size();i++)
	{
		found = vstr[i].find(wd);
		if (found != std::string::npos) {
				idx = i;

		};
	};
	return idx;
};

int findlw(vector<string>& vstr,int ls, int le, string wd) {
	int idx=-1;
	size_t found;
	for (int i=ls+1;i<le;i++)
	{
		found = vstr[i].find(wd);
		if (found != std::string::npos) {
			if (found == 0)
				idx = i;
		};
	};

	return idx;
};

vector<int> findlvw(vector<string>& vstr,int ls,int le,string wd) {
	vector<int> idx;
	size_t found;
	for (int i=ls+1;i<le;i++)
	{
		found = vstr[i].find(wd);
		if (found!=std::string::npos)
			idx.push_back(i);
	};

	return idx;
};

string rmspaces(string str) {
	size_t id;
	bool getout = 0;
	while(getout == 0) {
		id = str.find(" ");
		if (id!=std::string::npos)
			str.erase(id,1);
		else
			getout = 1;
	};
	return str;
};

vector<string> rmblanklines(vector<string>& nns) {
	vector<string> nns2;
	string str;
	for (int i = 0;i < (int)nns.size();i++) {
		str = nns[i];
		if (nns[i] != "") {
			nns2.push_back(str);
		}
	};
	return nns2;
};

vector<string> rmcomments(vector<string>& nns) {
	vector<string> nns2;
	string str, key;
	size_t id;
	key = "//";
	for (int i=0;i < (int)nns.size();i++) {
		str = nns[i];
		id = str.find(key);
		if (id != std::string::npos) {
			if (id > 0) {
				str.erase(id, str.size());
				nns2.push_back(str);
			}
		}else nns2.push_back(str);
	};
	return nns2;
};

int getrmtype(string& str) {
	size_t fd = str.find(":");
	if (fd == std::string::npos) {
		return UTYPE_POP;
	}
	else {
		string tmp = str.substr(0, fd);
		if (tmp == "u") {
			str.erase(0,fd+1);
			return UTYPE_NSU;
		}
		else {
			return -1; //Unkown character
		};
	};
};